/* ctgCoord.c was originally generated by the autoSql program, which also 
 * generated ctgCoord.h and ctgCoord.sql.  This module links the database and the RAM 
 * representation of objects. */

#include "common.h"
#include "jksql.h"
#include "ctgCoord.h"

void ctgCoordStaticLoad(char **row, struct ctgCoord *ret)
/* Load a row from ctgCoord table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{
int sizeOne,i;
char *s;

ret->ctgName = row[0];
ret->ctgId = row[1];
ret->start = sqlSigned(row[2]);
ret->end = sqlSigned(row[3]);
strcpy(ret->strand, row[4]);
strcpy(ret->phase, row[5]);
ret->clone = row[6];
ret->gi = sqlSigned(row[7]);
}

struct ctgCoord *ctgCoordLoad(char **row)
/* Load a ctgCoord from row fetched with select * from ctgCoord
 * from database.  Dispose of this with ctgCoordFree(). */
{
struct ctgCoord *ret;
int sizeOne,i;
char *s;

AllocVar(ret);
ret->ctgName = cloneString(row[0]);
ret->ctgId = cloneString(row[1]);
ret->start = sqlSigned(row[2]);
ret->end = sqlSigned(row[3]);
strcpy(ret->strand, row[4]);
strcpy(ret->phase, row[5]);
ret->clone = cloneString(row[6]);
ret->gi = sqlSigned(row[7]);
return ret;
}

struct ctgCoord *ctgCoordCommaIn(char **pS, struct ctgCoord *ret)
/* Create a ctgCoord out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new ctgCoord */
{
char *s = *pS;
int i;

if (ret == NULL)
    AllocVar(ret);
ret->ctgName = sqlStringComma(&s);
ret->ctgId = sqlStringComma(&s);
ret->start = sqlSignedComma(&s);
ret->end = sqlSignedComma(&s);
sqlFixedStringComma(&s, ret->strand, sizeof(ret->strand));
sqlFixedStringComma(&s, ret->phase, sizeof(ret->phase));
ret->clone = sqlStringComma(&s);
ret->gi = sqlSignedComma(&s);
*pS = s;
return ret;
}

void ctgCoordFree(struct ctgCoord **pEl)
/* Free a single dynamically allocated ctgCoord such as created
 * with ctgCoordLoad(). */
{
struct ctgCoord *el;

if ((el = *pEl) == NULL) return;
freeMem(el->ctgName);
freeMem(el->ctgId);
freeMem(el->clone);
freez(pEl);
}

void ctgCoordFreeList(struct ctgCoord **pList)
/* Free a list of dynamically allocated ctgCoord's */
{
struct ctgCoord *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    ctgCoordFree(&el);
    }
*pList = NULL;
}

void ctgCoordOutput(struct ctgCoord *el, FILE *f, char sep, char lastSep) 
/* Print out ctgCoord.  Separate fields with sep. Follow last field with lastSep. */
{
int i;
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->ctgName, sep);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->ctgId, sep);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%d", el->start, sep);
fputc(sep,f);
fprintf(f, "%d", el->end, sep);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->strand, sep);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->phase, sep);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->clone, sep);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%d", el->gi, lastSep);
fputc(lastSep,f);
}

